Unit IA12R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure IA12R(var F :Array of Real; var T :Array of Real;
                var P :Array of Real; M :Integer; N :Integer);

implementation

procedure IA12R(var F :Array of Real; var T :Array of Real;
                var P :Array of Real; M :Integer; N :Integer);
var
K,L,K1,K2,L1,KM,I,J :Integer;
FM,FK,T1,T2,R,D,PK :Real;
const
SYS053 :Real = 3.4E17;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11;
begin
L := 1;
if ( M = 0 ) 
 then goto _9;
T1 := SYS053;
if ( M > 0 ) 
 then T1 := -T1;
if ( N <= 1 ) 
 then goto _9;
_1:
L1 := L+1;
KM := L;
FM := F[L-1];
D := 0.0;
for K:=L1 to N do
 begin
  FK := F[K-1];
  PK := P[K-1];
  K1 := K-1;
  I := 0;
  for J:=L to K1 do
   begin
    T2 := PK*P[J-1]*(F[J-1]-FK)/(P[J-1]+PK);
    R := T2-D;
    if ( M < 0 ) 
     then R := -R;
    if ( R < 0.0 ) 
     then goto _2;
    I := 1;
    K2 := J;
    D := T2;
_2:
   end;
  if ( I = 0 ) 
   then goto _3;
  T2 := (P[K2-1]*F[K2-1]+PK*FK)/(P[K2-1]+PK);
  R := T2-FM;
  if ( M < 0 ) 
   then R := -R;
  if ( R > 0.0 ) 
   then goto _3;
  FM := T2;
  KM := K;
_3:
 end;
if ( M < 0 ) 
 then goto _4;
T1 := EMax1(T1,FM);
goto _5;
_4:
T1 := EMin1(T1,FM);
_5:
for K:=L to KM do
 begin
_6:
  T[K-1] := T1;
 end;
L := KM+1;
if ( L-N ) < 0
 then goto _1
 else if ( L-N ) > 0
       then goto _11
       else goto _7;
_7:
if ( M < 0 ) 
 then goto _8;
T[N-1] := EMax1(T1,F[N-1]);
goto _11;
_8:
T[N-1] := EMin1(T1,F[N-1]);
goto _11;
_9:
for K:=1 to N do
 begin
_10:
  T[K-1] := F[K-1];
 end;
_11:
end;

end.
